# DoraCMS 2.1.4

![DoraCMS](https://www.html-js.cn/static/upload/images/ueditor/1041325089330696192.png "DoraCMS")

## 2.1.4 版本更新

1、使用eggjs 重构了服务端

2、使用 vue-cli, single-spa 重构了后台界面

3、修复了一些异常和bug



## 说明

### DoraCMS 使用的技术栈：

```
1、nodejs 10.15.0 + eggjs 2
2、vue-cli
3、mongodb 4+
```

演示地址： [前端开发俱乐部](https://www.html-js.cn)  

后台登录： https://www.html-js.cn/dr-admin  
测试账号：doracms/123456  



## 目录结构

```javascript
oas-system
├── README.md
├── app
│   ├── assets
│   │   ├── gulpfile.js
│   │   ├── package.json
│   │   ├── postcss.config.js
│   │   └── themes
│   ├── bootstrap
│   │   ├── global.js
│   │   ├── index.js
│   │   └── tags.js
│   ├── controller
│   │   ├── api
│   │   ├── manage
│   │   └── page
│   ├── extend
│   │   ├── application.js
│   │   ├── context.js
│   │   ├── filter.js
│   │   └── helper.js
│   ├── middleware
│   │   ├── authAdminPower.js
│   │   ├── authAdminToken.js
│   │   ├── authApiToken.js
│   │   ├── authPage.js
│   │   ├── authUserToken.js
│   │   ├── compress.js
│   │   ├── crossHeader.js
│   │   └── notfound_handler.js
│   ├── model
│   │   ├── adminGroup.js
│   │   ├── adminResource.js
│   │   ├── adminUser.js
│   │   ├── plugin.js
│   │   └── systemConfig.js
│   ├── public
│   │   ├── favicon.ico
│   │   ├── plugins
│   │   ├── themes
│   │   └── upload
│   ├── router
│   │   ├── api.js
│   │   ├── home.js
│   │   ├── manage.js
│   │   └── users.js
│   ├── router.js
│   ├── schedule
│   │   └── backup_data.js
│   ├── service
│   │   ├── adminGroup.js
│   │   ├── adminResource.js
│   │   ├── adminUser.js
│   │   ├── general.js
│   │   ├── plugin.js
│   │   └── systemConfig.js
│   ├── utils
│   │   ├── authToken.js
│   │   ├── cache.js
│   │   ├── crypto.js
│   │   ├── index.js
│   │   ├── memoryCache.js
│   │   ├── mime.js
│   │   ├── redis.js
│   │   ├── siteFunc.js
│   │   ├── validatorUtil.js
│   │   └── validators.js
│   ├── validate
│   │   ├── adminGroup.js
│   │   ├── adminResource.js
│   │   ├── adminUser.js
│   │   ├── index.js
│   │   ├── plugin.js
│   │   └── systemConfig.js
│   └── view
│       ├── dorawhite
│       ├── manage
│       └── qingyulan
├── app.js
├── appveyor.yml
├── backstage
│   ├── adminGroup
│   │ 
│   ├── adminResource
│   │ 
│   ├── adminUser
│   │ 
│   │ 
│   ├── ads
│   │ 
│   ├── announce
│   │ 
│   ├── backUpData
│   │ 
│   ├── build
│   │   ├── buildModules.js
│   │   ├── installModules.js
│   │   ├── package.json
│   │   └── utils.js
│   ├── content
│   │ 
│   ├── contentCategory
│   │ 
│   ├── contentMessage
│   │ 
│   ├── contentTags
│   │ 
│   ├── contentTemp
│   │ 
│   ├── dashboard
│   │ 
│   ├── dist
│   │ 
│   ├── helpCenter
│   │ 
│   ├── navbar
│   │ 
│   ├── plugin
│   │ 
│   ├── publicMethods
│   │ 
│   ├── regUser
│   │ 
│   ├── renderCms
│   │ 
│   ├── systemConfig
│   │ 
│   ├── systemNotify
│   │ 
│   ├── systemOptionLog
│   │ 
│   ├── templateConfig
│   │ 
│   └── versionManage
│
├── build
│   ├── dropdb.js
│   ├── publishConfig.js
│   ├── renderPro.js
│   └── restore.js
├── config
│   ├── config.default.js
│   ├── config.local.js
│   ├── config.prod.js
│   ├── locale
│   │   ├── en-US.json
│   │   ├── zh-CN.json
│   │   └── zh-TW.json
│   └── plugin.js
│ 
├── databak
├── dist
│
├── index.js
├── lib
│   ├── framework.js
│   └── plugin
│       ├── egg-dora-ads
│       ├── egg-dora-announce
│       ├── egg-dora-backupdata
│       ├── egg-dora-content
│       ├── egg-dora-contentcategory
│       ├── egg-dora-contentmessage
│       ├── egg-dora-contenttags
│       ├── egg-dora-contenttemp
│       ├── egg-dora-helpcenter
│       ├── egg-dora-middlestage
│       ├── egg-dora-reguser
│       ├── egg-dora-rendercms
│       ├── egg-dora-sitemessage
│       ├── egg-dora-systemnotify
│       ├── egg-dora-systemoptionlog
│       ├── egg-dora-templateconfig
│       ├── egg-dora-versionmanage
│       └── publish.js
│
├── package.json
├── robots.txt
├── test
│   ├── fixtures
│   │   └── example
│   └── framework.test.js
└── tree.md

```





## 开发环境准备工作:

### 安装最新稳定版 NodeJS (10.15.0):
```javascript
https://nodejs.org/zh-cn/
```


### 安装并启动 Mongodb (++mongodb不要设置密码访问++)
```javascript
https://www.mongodb.com/download-center#community
```

### 安装全局依赖
```javascript
npm install egg-scripts -g   // eggjs 脚本执行
npm install gulp -g  // 脚本构建
```


### 安装本系统依赖（代码根目录）
```javascript
npm install
```


### 设置环境变量（以mac为例，修改 .bash_profile文件）

```javascript
vi ~/.bash_profile

export NODE_ENV=development
MONGODBPATH=/Users/Dora/Documents/dora/soft/mongodb/bin
PATH="${MONGODBPATH}:${PATH}"
export PATH

source ~/.bash_profile
```

> 以上步骤做了两件事情：  
1、设置nodejs环境变量为 development,生产环境记得改为 production  
2、将mongodb bin 目录添加到全局变量中，便于在终端的任何位置执行mongo脚本,注意改成自己安装mongodb的实际路径  



### 初始化数据
```javascript
npm run init
```

### 开发模式启动
```javascript
npm run dev
```

### 生产模式启动
```javascript
npm start
```
### 生产模式停止
```javascript
npm run stop
```

### 首页
```javascript
http://localhost:8080
```

### 后台登录
```javascript
http://localhost:8080/dr-admin
登录账号：doramart/123456    doracms/123456
```

## 捐赠
如果你发现DoraCMS很有用，可以请生哥喝杯咖啡(⊙o⊙)哦
<img width="650" src="http://cdn.html-js.cn/payme.jpg" alt="">

# LICENSE

MIT


